// FILENAME:	Siege_Battle_Star.cs
//
// DESIGNER:      Temujin
//
// BASED ON:      DM_City_on_the_edge and WAR_martian_standoff
//------------------------------------------------------------------------------

$missionName = "SIEGE_Battle_Star";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("siege.cs");

$shieldgens = 4;

// Herc X/Y coordinates must be defined for where they respawn.
// HeavyHercs == 1 & 2, LightHercs == 3 & 4, Tanks == 5 & 6
$Herc1X = 0;
$Herc1Y = -250;
$Herc2X = 0;
$Herc2Y = 250;
$Herc3X = 450;
$Herc3Y = 450;
$Herc4X = -450;
$Herc4Y = -450;
$Herc5X = -250;
$Herc5Y = 0;
$Herc6X = 250;
$Herc6Y = 0;

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to " @ $missionName @ "!  SIEGE is a one-way WAR map.  Please read the <F6>?<F0> tab now.");
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
   marsSounds();

   initGlobalVars();
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Shield Gen Code
/////////////////////////////////////////////////////////////////////////////////////////////

function ShieldGen::structure::onDestroyed( %this, %who )
{
   $shieldgens -= 1;
   if($shieldgens < 1) {
      %player = playerManager::vehicleIdToPlayerNum( %who );
      %txt = "The last Shield Generator has been destroyed. The Deus Irae is unprotected!";
      say(IDSTR_TEAM_BLUE, 1234, "<F5>ATTENTION: " @ %txt @ "<F0>",  "ene_struct_dest.wav");    
      say(IDSTR_TEAM_RED, 1234, "<F5>WARNING: " @ %txt @ "<F0>", "friend_struct_des.wav");
      lowerfields(83);  
   }
   else {
      %player = playerManager::vehicleIdToPlayerNum( %who );
      %txt = "A Shield Generator has been destroyed. Only " @ $shieldgens @ " remaining.";
      say(IDSTR_TEAM_BLUE, 1234, "<F5>ATTENTION: " @ %txt @ "<F0>",  "ene_struct_dest.wav");    
      say(IDSTR_TEAM_RED, 1234, "<F5>WARNING: " @ %txt @ "<F0>", "friend_struct_des.wav");    
   }
}

function lowerfields(%height)
{
   %newheight = %height - 0.25;

   %field = getObjectId("MissionGroup\\RED\\Field1");
   lower( %height, %field );   

   %field = getObjectId("MissionGroup\\RED\\Field2");
   lower( %height, %field );

   %field = getObjectId("MissionGroup\\RED\\Field3");
   lower90( %height, %field );   

   %field = getObjectId("MissionGroup\\RED\\Field4");
   lower90( %height, %field );

   if(%newheight > 0) 
      schedule("lowerfields(" @ %newheight @ ");", 0.1);
}

function lower( %z, %field )
{
   %x = getPosition(%field,x);
   %y = getPosition(%field,y);

   setPosition(%field, %x, %y, %z);
}

function lower90( %z, %field )
{
   %x = getPosition(%field,x);
   %y = getPosition(%field,y);

   setPosition(%field, %x, %y, %z, 90);
}

// Mission Cleanup...

function onMissionEnd()
{
deleteObject("MissionGroup\\Hercs");
deleteObject("MissionGroup\\RED");
deleteObject("MissionGroup");
deleteObject("MissionCleanup");

deleteFunctions("lower*");

deleteVariables("$shieldgens");
}